#include "main.h"

// ---------------------------------------------------------------------------------------
void ADC_Init(void)
{
  DDRA &= ~(1<< 5);
  DDRA &= ~(1<< 6);
  DDRA &= ~(1<< 7);
  
  ADMUX = 0;
  ADCSRA = 0x86;
}

// ---------------------------------------------------------------------------------------
 int ReadADC(unsigned char adc_input)
{
 unsigned int i; 
 ADMUX = adc_input;
 ADCSRA |= 0x40;
 for(i=0;i<5000;i++);
 while ((ADCSRA & 0x10) == 0);
 ADCSRA |= 0x10;
 //return ((ADCW*25)/4)-2350 ;   // read ad and calc. temp.
 return (ADCW & 0x03FF);
}

// ---------------------------------------------------------------------------------------
void GetTemperature(void)
{
  for (unsigned char i=0;i<3;i++)
  {  
     int tmp;
     vars.type_int[i*2] = ReadADC(5 + i);
	 tmp = (vars.type_int[i*2]*25)/4 - 2450;
	 if (tmp > 999) tmp = 999;
	 else if (tmp < 0) tmp = 0;
	 vars.type_char[(i*2+1)*2] =   tmp / 10;
	 vars.type_char[(i*2+1)*2+1] = tmp % 10;
  }
   
/*

 AN5_Raw = ReadADC(5);
 KTY1 = (AN5_Raw*25)/4-2450;      // Umrechnen auf Temperatur
 if (KTY1 > 999) KTY1=999;
  else if (KTY1<0) KTY1=0;
 
 AN6_Raw = ReadADC(6);
 KTY2 = (AN6_Raw*25)/4-2450;
 if (KTY2 > 999) KTY2=999;
  else if (KTY2<0) KTY2=0;
  
 AN7_Raw = ReadADC(7);
 KTY3 = (AN7_Raw*25)/4-2450;
 if (KTY3 > 999) KTY3=999;
  else if (KTY3<0) KTY3=0;
  
  */
}
