/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig
          (C) 2005 Mark Haemmerling <avr.webserver@markh.de>
          (C) 2006 Ingo Busker http://www.mikrocontroller.com
#######################################################################################*/


#include "main.h"
#include "httpd.h"

#include <webpage.h>

//MH//
#define BLOCK_SIZE BlockSize // aus fat.h

int substitute(unsigned char val_type, unsigned char var_addr, unsigned char size, unsigned char *dest, unsigned char *format);

/*
//MH//
Todo:
- content type im header entsprechend anpassen:
  htm -> text/html
  jpg -> image/jpeg (jpg?)
  gif -> image/gif
  png -> image/png
  *   -> text/plain
*/

//MH:
// bestimmung der stackposition allgemein in der tcp.c machen, und adresse an ftpd/httpd...
// bergeben. so da nicht jeder daemon das selbst machen mu. mu er ja eh, weil tcp=verbindungsorientiert

//############################################################################
//HTTP daemon 
//############################################################################
void httpd (char* buffer,int *bufferlen) {	
	unsigned int tcpdata;
	//Errechnet startpunkt der Daten im Tcp buffer
	//IP Headerlnge + TCP Headerlnge + Ethernetframe
	tcpdata = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;

	//Verwaltung Stackpointer

	unsigned char a;//Stack Speichplatz Default (0..10)
	if (TCP_Stack(buffer,bufferlen,&a) == 1) return; //keine Daten fr Anwendung

	tcp_socket = &tcpsockets[a]; //Pointer auf tcpsockets[a] holen
	
	//berprft HTTP Header 
	if ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0 && tcp_socket->Status == TCP_SOCKET_OPEN1) {
		unsigned char extension = 0;
			
		//Pointerold auf 404-Seite
		pointerold = Page_404;
		
		//File_Name entspricht 8.3 & Endmakierung
		unsigned char File_Name[13];

		//berprft Header nach "GET /File_Name HTTP....."
		if (memcmp(&buffer[tcpdata], "GET /",5) == 0) {
			char *tmppointer = &buffer[tcpdata + 5];
			unsigned char counter;
			
			tcp_socket->Open_Tag_Len = 0;
			//Der Header wird durchsucht beginnend bei GET /
			counter = 0;
			while (1) {
				if (counter >= (sizeof(File_Name) - 1)) break;
				if (*tmppointer == ' ') break;
				if (*tmppointer == '?') {
					// CGI-Daten beginnen hier:
					unsigned char *pos_addr, *pos_value;
					unsigned char var_type, tmp;
					tmppointer++;
					while (1) {
						unsigned char var_addr;
						// !> if zu weit: break;
						var_type = *tmppointer; // typen-code (b,w...)
						tmppointer++; // beginn der adresse
						pos_addr = tmppointer; // merke beginn der addr
						while (*tmppointer != '=') tmppointer++; // !> abbruch wenn zu lang!
						*tmppointer = '\0'; // fuer atoi()
						tmppointer++; // auf beginn des wertes
						pos_value = tmppointer; // merke beginn des wertes
						while ((*tmppointer != '&') && (*tmppointer != ' ')) tmppointer++; // !> abbruch wenn zu lang!
						tmp = *tmppointer; // merke trennzeichen
						*tmppointer = '\0';
						if (var_type == 'b') { // !> var_addr prfen!!!! darf nur in zugelassenen bereich schreiben!!! < VARS_RW_BOUNDARY oder so
							unsigned char pos_bit = 0, shift = 0xff; // shift ist >= 8, um standardmig bitzuweisung zu verhindern
							while (pos_addr+pos_bit+2 < pos_value) { // solange ein '.' kommen kann
								if (pos_addr[pos_bit] == '.') {
									shift = pos_addr[pos_bit+1] - '0';
									pos_addr[pos_bit] = '\0'; // fuer atoi()
									break;
								}
								pos_bit++;
							}
							var_addr = atoi(pos_addr);
							if (var_addr < (VARS_RW_BYTES)) {
								if (shift < 8) {
									if (atoi(pos_value) != 0) {
										vars.type_char[var_addr] |= (1<<shift);
									} else {
										vars.type_char[atoi(pos_addr)] &= ~(1<<shift);
									}
								} else {
									vars.type_char[atoi(pos_addr)] = atoi(pos_value);
								}
							}
						} else if (var_type == 'w') {
							var_addr = atoi(pos_addr);
							if (var_addr < (VARS_RW_BYTES / 2)) {
								vars.type_int[atoi(pos_addr)] = atoi(pos_value);
							}
						}
						tmppointer++;
						if (tmp == ' ') break; // wenn trennzeichen ein ' ' war, abbruch
					}
					break;
				}
				File_Name[counter] = *tmppointer;
				counter++;
				tmppointer++;
			}
				
			//Endmakierung setzen
			File_Name[counter] = '\0';
			
			//Enthlt der Header keinen File Namen ist dieser 'index.htm' oder 'index.asp'
			if (File_Name[0] == '\0')
			  if (MMC_Present) sprintf(File_Name, "index.asp");                        
			 
			   else sprintf(File_Name, "index.htm");
				// !> hier erst durchprobieren:

			printf(PSTR("File-Request: '"));
			printf(File_Name);
			printf("'\n\r");

			counter = 0;
			while (File_Name[counter] != 0) {
				if (File_Name[counter] == '.') { extension = counter; break; }
				counter++;
			}

			#if USE_MMC
			//Durchsucht Root Verzeichnis nach File Namen
			//unsigned char Dir_Attrib;

			//Lade Cluster fr das File welches in File_Name steht 
			tcp_socket->Cluster = 0; //suche im Root Directory
		//	if (Search_File(File_Name, &tcp_socket->Cluster, &tcp_socket->File_Size, &Dir_Attrib, &buffer[tcpdata]) == 1)
		     if (FileOpen(File_Name, 'r', &(tcp_socket->fp)))
			 {
				tcp_socket->File_Block_Counter = 0;
				tcp_socket->Cluster = 100;
			} else {
				//wurde das File nicht gefunden, wird Seite aus Flashspeicher angezeigt
				tcp_socket->Cluster = 0;
			}
			#endif //USE_MMC
		}
		
		if ( memcmp(File_Name,"index.htm",9) == 0)           pointerold = Page1;
		else if ( memcmp(File_Name,"rakete.gif",10) == 0)    pointerold = Page2;
		
		

#if USE_MCA25_CAM
  if(CAM_Enable)
  { 	
	if (memcmp(File_Name,"cam",3) == 0){
			//cam picture requestet
			if (mca25_cam_busy_for_socket == MCA25_NOT_BUSY){ 
				//new image -> status = 0
				mca25_cam_status = MCA25_FIRST_DATA;
				//cam is reserved für socket a
				mca25_cam_busy_for_socket = a;
			}else	if (mca25_cam_busy_for_socket == a){
				//ooooops, cam pic tranfer has been canceled
				//we need to reset the camera...
				mca25_cam_status = MCA25_SKIP_PICTURE;
				mca25_cam_busy_for_socket = a;
			}else if (mca25_cam_busy_for_socket == MCA25_STILL_BUSY){
				//same as above but there was another request
				//before -> skip picture now
				mca25_cam_status = MCA25_SKIP_PICTURE;
				mca25_cam_busy_for_socket = a;
			}else{
				//cam is busy -> show busy jpg
				pointerold = CAM_BUSY_JPG;
			}
		}else{
			//cam picture _NOT_ requested !
			if (mca25_cam_busy_for_socket == a){
				//if there was an picture request before
				//which was interrupted, we need to 
				//skip the picture later
				mca25_cam_status = MCA25_SKIP_PICTURE;
				mca25_cam_busy_for_socket = MCA25_STILL_BUSY;
			}
		}
   }		
#endif 

		//Speichert Sequenzcounter und Aknowledgecounter
		tcp_store(buffer);	
	
		//Setzen des Ack Flags und PSH Flags	
		buffer[TCP_HDRFLAGS+1] = ACK_FLAG | PSH_FLAG;
		//erzeuge HTTP antwortheader

#if USE_MCA25_CAM
		if (CAM_Enable && memcmp(File_Name,"cam",3) == 0) { 	tcp_add_data (HTTP_200_JPEG,buffer,bufferlen); } 
		else
#endif		
		if (tcp_socket->Cluster == 0) {
			tcp_add_data (HTTP_404,buffer,bufferlen);
		} else if (strcasecmp(File_Name+extension, ".asp") == 0) {
			tcp_socket->Subst_Tags = 1;
			tcp_add_data (HTTP_200_HTML,buffer,bufferlen);
		} else if (strcasecmp(File_Name+extension, ".htm") == 0) {
			tcp_socket->Subst_Tags = 0;
			tcp_add_data (HTTP_200_HTML,buffer,bufferlen);
		} else if (strcasecmp(File_Name+extension, ".jpg") == 0) {
			tcp_socket->Subst_Tags = 0;
			tcp_add_data (HTTP_200_JPEG,buffer,bufferlen);
		} else {
			tcp_socket->Subst_Tags = 0;
			tcp_add_data (HTTP_200_PLAIN,buffer,bufferlen);
		}
		//Erzeugt ein TCP Packet 
		tcp_make(buffer);
		//Sendet das erzeugte TCP Packet 
		Write_Ethernet_Frame (buffer,*bufferlen);
		//(Ethernet Farne war aber voll) Weiters Frame mu gesendet werden!
		tcp_socket->Status = TCP_SOCKET_OPEN2;
		tcp_socket->Pointer = pointerold;
		return;
		}
	
	//Senden der Webseite bzw. Daten war noch nicht Fertig (Ethernet Farne war aber voll)
	if (tcp_socket->Status == TCP_SOCKET_OPEN2) {
		unsigned char remaining_data = 0;
	
		//Setzen des Ack Flags und PSH Flags	
		buffer[TCP_HDRFLAGS+1] = ACK_FLAG | PSH_FLAG;
		//Speichert Sequenzcounter und Aknowledgecounter
		tcp_store(buffer);		
		//erzeugt Seiten Packet
		
		#if USE_MMC
		#define BLOCK_SIZE 512
		
		if(tcp_socket->Cluster != 0) 
		{
//			read_file_and_expand(tcp_socket->Cluster, buffer+tcpdata, tcp_socket->File_Block_Counter);
			unsigned int use_size;
			unsigned int a;
			unsigned char *work_buffer = buffer+tcpdata; // zur Vereinfachung

//			printf("blk=%u, us=%u\n", tcp_socket->File_Block_Counter, use_size);
			
			// hier evtl. alten block nochmal laden und verschieben!
			if ((tcp_socket->File_Block_Counter > 0) && (tcp_socket->Open_Tag_Len > 0)) 
			{
				// letzter Block enthielt am Ende ein offenes Tag.
				// dieses Tag wird nun vor diesen Block kopiert, so da es komplett verarbeitet werden kann
				for (a = 0; a < tcp_socket->Open_Tag_Len; a++)
                {
					work_buffer[a] = work_buffer[BLOCK_SIZE - tcp_socket->Open_Tag_Len + a];
					
				}
			
			}	
			
			FileBuffer = work_buffer + tcp_socket->Open_Tag_Len;
			use_size = FileReadSector(&(tcp_socket->fp)); 
			if(use_size == 512)	remaining_data = 1; //es wurden noch nicht alle Daten gesendet					
			  else remaining_data = 0; //es wurden alle Daten gesendet
			
            use_size += tcp_socket->Open_Tag_Len;	
			tcp_socket->File_Block_Counter++;
			tcp_socket->Open_Tag_Len = 0;

			// Tags ersetzen (nur wenn geeigneter content type)
			if (tcp_socket->Subst_Tags) {;
				a = 0;
				while (a < use_size) {
					if (work_buffer[a] == '`') { // Anfang eines Tags ('{') erkannt
						unsigned char val_type, i, j, tag_len, subst_len = 0;
						unsigned char var_addr;
						unsigned char boolean = 0xff; // 0=false, 1=true, sonst=keine bool-auswertung
						unsigned char format[6];
						
						// !> beim weiteren parsen immer checken, da tag_len nicht berschritten wird,
						// bzw. } nicht erreicht wird -> sonst abbruch und tag durch nichts ersetzen
						// also subst_len auf default (=0) lassen, tag_len ist ja schon bekannt
						// also wird tag durch nichts ersetzt, sprich gelscht bzw. ignoriert
						
						i = 1; // finde heraus, ob tag offen ist. beginne mit suche direkt hinter dem '{'
						while ((a+i < use_size) && (work_buffer[a+i] != '`')) i++;
						if (!(a+i < use_size)) { // also sind wir am ende angekommen -> offenes tag
							tcp_socket->Open_Tag_Len = (use_size - a);
							break;
						}
						tag_len = i+1;
			
						// typ der einzusetzenden variablen erkennen (b, w):
						val_type = work_buffer[a+1];
						
						// adresse der einzusetzenden variablen bestimmen:
						i = 0;
						// !> schauen, da kein } kommt (falsches format)... was passiert, wenn zu weit geparst wurde??
						while ((i < 4) && (work_buffer[a+2+i] != ':') && (work_buffer[a+2+i] != '.')) i++;

						if (work_buffer[a+2+i] == '.') { // trennzeichen war '.', also bitnr. parsen
// weiter unten abbrechen							if (val_type != 'b') break;
							boolean = work_buffer[a+3+i] - '0'; // noch bedeutet diese variable nur nummer des bits!!
						}						
		
						// adresse in integer verwandeln:
						work_buffer[a+2+i] = '\0';
						var_addr = atoi(work_buffer+a+2);
		
						if (boolean < 8) { // boolsche auswertung
							// ersten doppelpunkt suchen (sollte eigentlich gleich dahinter kommen)
							i += 4;
							while (work_buffer[a+i] != ':') i++; // !> abbruch wenn zu lang
							i++;
							// true-teil beginnt hier
							j = 0;
							while (work_buffer[a+i+j] != ':') j++; // lnge des true-teils bestimmen

							if (val_type == 'b') {
								if (vars.type_char[var_addr] & (1<<boolean)) {
									memmove(work_buffer+a, work_buffer+a+i, j);
									subst_len = j;
								} else {
									i += j+1;
									j = 0;
									while (work_buffer[a+i+j] != '`') j++; // lnge des false-teils bestimmen
									memmove(work_buffer+a, work_buffer+a+i, j);
									subst_len = j;
								}
							}
						} else {
							// formatstring bestimmen:
							format[0] = '%';
							j = 0;
							//if(work_buffer[a+2+i] == ':')              // fr val_type = 'x'...
							 while (work_buffer[a+3+i+j] != '`') {
						 		if (j >= sizeof(format)-1) break; // format luft ber -> undefiniert!!
					 			format[j+1] = work_buffer[a+3+i+j]; // in lokalen formatstring kopieren
								j++;
				 			 }
							format[j+1] = '\0';

							// herausfinden wie lang das ergebnis wird
							subst_len = substitute(val_type, var_addr, 0, NULL, format); // j ist nun Lnge des neuen Stckes
						}
						
						// Puffer entsprechend verlngern oder krzen (Rest wird verschoben)
						memmove(work_buffer+a+subst_len, work_buffer+a+tag_len, use_size-a-tag_len);
						use_size += subst_len - tag_len;

						if (!(boolean < 8)) {
							// nun ohne \0 direkt in den puffer hineinkopieren
							substitute(val_type, var_addr, subst_len, work_buffer+a, format);
						}

						a += subst_len; // ber ersetzten teil springen (tags knnen nicht andere tags enthalten)
						// fr verschachtelte tags: anzahl enthaltener tags mte gezhlt werden ("%{" -> tags++, "}" -> tags--)
						// erst bei tags == 0 mte auf "}" reagiert werden... offene tags auch sauber handeln! is was fr 2.0 :)
					} else {
						a++;
					}
				}
	
				// Puffer ggf. bis zum Anfang des offenen Tags krzen:
				use_size -= tcp_socket->Open_Tag_Len;
				//printf("OTL=%u\n", tcp_socket->Open_Tag_Len);
			} // ende if (contenttype==html)

			TCP_New_Packtlen(buffer, bufferlen, tcpdata + use_size);
			goto endmakepacket;
		}
		#endif //USE_MMC

		
		#if USE_MCA25_CAM
			if(CAM_Enable )
			{
			if ( mca25_cam_busy_for_socket == a ){
				if (mca25_copy_image_data_to_tcp_buffer(buffer, bufferlen) == 1){
					//more packets:
					remaining_data = 1;
				}else{
					//last packet
					remaining_data = 0;
					mca25_cam_busy_for_socket = MCA25_NOT_BUSY;
				}
				goto endmakepacket;
			}
			}
#endif

	
		//MH// dies hier wird bersprungen wenn daten von sd kommen (durch goto hier oben!)
		pointerold = tcp_socket->Pointer;
		remaining_data = tcp_add_data (pointerold,buffer,bufferlen);
		tcp_socket->Pointer = pointerold;

		endmakepacket:

		//Erzeugt ein TCP Packet 
		tcp_make(buffer);			
		//Sendet das erzeugte TCP Packet 
		Write_Ethernet_Frame (buffer,*bufferlen);	
		if (remaining_data == 0) {
			#if USE_MMC
			tcp_socket->Cluster = 0;
			#endif //USE_MMC
			tcp_socket->Status = TCP_SOCKET_CLOSE;
		}
		return;		
	}
	return;
}

int substitute(unsigned char val_type, unsigned char var_addr, unsigned char size, unsigned char *dest, unsigned char *format) {
	unsigned char behind = dest[size];
	unsigned char length;

	size++;
	if (val_type == 'b') 
	{
		length = snprintf(dest, size, format, vars.type_char[var_addr]);
	} else if (val_type == 'w') 
	{
		length = snprintf(dest, size, format, vars.type_int[var_addr]);
	} else if (val_type == 'x')   // TODO
	{
		switch (var_addr)
		{
		  case 1: length = snprintf(dest, size, "%d.%d.%d.%d",MYIP[0],MYIP[1],MYIP[2],MYIP[3]); break;	 
		  case 2: length = snprintf(dest, size, "%02X-%02X-%02X-%02X-%02X-%02X",mymac[0],mymac[1],mymac[2],mymac[3],mymac[4],mymac[5]); break;
		} 
		
	} else length = 0;
	
	if (dest != NULL) { dest[size-1] = behind; length--; }
	return length;
}
