/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

Bei Fragen und Verbesserungen wendet euch per EMail an
mail@ulrichradig.de

Erweiterungen: (C) 2006 Ingo Busker http://www.mikrocontroller.com

Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
GNU General Public License, wie von der Free Software Foundation verffentlicht, 
weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
(nach Ihrer Option) jeder spteren Version. 

Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
Programm erhalten haben. 
Falls nicht, schreiben Sie an die Free Software Foundation, 
Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
#######################################################################################*/

#include "main.h"


//Die beiden hier knnte man vieleicht doch besser ins RAM legen. Holgi
//MAC Addresse des Web Servers
unsigned char MYIP[] =  { 192,168,0,160 };
unsigned char mymac[] = {30,10,43,43,45,77};

const unsigned char ROUTER_IP [] =  { 192,168,1,88  };
const unsigned char FTP_IP[] =      { 192,168,1,88 }; 
//const unsigned char NTP_IP[] =      { 129,69,1,153 }; 
const unsigned char NTP_IP[] =      { 192,168,1,88  }; 
const unsigned char SMTP_IP[] =     { 213,165,64,20 }; 

struct str_ARP_Table ARP_Table[NUM_ARP_ENTRIES];


//IP Addresse des Web Servers

char packet[MTU_SIZE];              
/*const char DefaultTCPPaket[62]= { 0x00 , 0x0f,  0x1f , 0x27 , 0xd0 , 0x24 , 0x00 , 0x20 , 0xe0 , 0x6b , 0x2f , 0x1e , 0x08 , 0x00 , 0x45 , 0x00 ,
							      0x00 , 0x30 , 0x00 , 0xa5 , 0x40 , 0x00 , 0x80 , 0x06 , 0x76 , 0x21 , 0xc0 , 0xa8 , 0x01 , 0x59 , 0xc0 , 0xa8 ,
								  0x01 , 0x58 , 0x04 , 0x08 , 0x00 , 0x15 , 0x06 , 0xe9 , 0xb0 , 0x3f , 0x00 , 0x00 , 0x00 , 0x00 , 0x70 , 0x02 ,
								  0x40 , 0x00 , 0x03 , 0xd8 , 0x00 , 0x00 , 0x02 , 0x04 , 0x05 , 0xb4 , 0x01 , 0x01 , 0x04 , 0x02 };
*/
#if USE_MMC
char FBuffer[512];
#endif

unsigned char MMC_Present;
unsigned char CAM_SD_Store_Enable = DEFAULT_CAM_STORE_ENABLE;
unsigned char CAM_Enable = DEFAULT_CAM_ENABLE;
unsigned int CAM_SD_Store_Time = DEFAULT_CAM_SOTRE_TIME;
unsigned char FTP_Push_Enable = DEFAULT_FTP_PUSH_ENABLE;
unsigned char ExternalTrigger = 0;

unsigned int AD_Timer;                               // Updateintervall fr AD-Werte

unsigned char InitNetworkCard(void)
{
  unsigned char code, wert;
  
  //for (wert = 0; wert  < 62; wert++) packet[wert] = DefaultTCPPaket[wert];    // copy a valid paket into buffer

#if USE_RTL8019
	Init_Realtek_Network_Card();

    if((wert = ReadRTL(0)) == 34) code = 1; else code = 0; 
	if (code) printf("\n\rNIC : Init RTL8019: Ok"); else { printf("\n\rERR: Init RTL8019: (%i) ERROR !!! --\n\r", wert); return(code); }
	
#else
	if(init_3c5x9()==0) code = 1; else code = 0;
   if (code) printf("\n\rNIC : Init 3C5x9: Ok"); else { printf("\n\rERR: Init 3C5x9: ERROR !!! --\n\r"); return(code); }
	
#endif

    
    return(code);
}

//--------------------------------------------------------------------------
void InitIP(void)
{
  for (int i=0; i < 4; i++) ARP_Table[ARP_TABLE_ENTRY_ROUTER].IP.Byte[i]    = ROUTER_IP[i]; 
  ARP_Table[ARP_TABLE_ENTRY_ROUTER].MAC_Received= 0;
  for (int i=0; i < 4; i++) ARP_Table[ARP_TABLE_ENTRY_FTPSERVER].IP.Byte[i] = FTP_IP[i];
  ARP_Table[ARP_TABLE_ENTRY_FTPSERVER].MAC_Received = 0;
  for (int i=0; i < 4; i++) ARP_Table[ARP_TABLE_ENTRY_NTPSERVER].IP.Byte[i] = NTP_IP[i];
  ARP_Table[ARP_TABLE_ENTRY_NTPSERVER].MAC_Received = 0;
  for (int i=0; i < 4; i++) ARP_Table[ARP_TABLE_ENTRY_SMTPSERVER].IP.Byte[i] = SMTP_IP[i];
  ARP_Table[ARP_TABLE_ENTRY_SMTPSERVER].MAC_Received = 0;


} 

//--------------------------------------------------------------------------
void RequestMACAddr(void)
{
  
 /* if (!ARP_Table[ARP_TABLE_ENTRY_ROUTER].MAC_Received) { cli(); ARP_Request(packet, &ARP_Table[ARP_TABLE_ENTRY_ROUTER]); sei();}
  else 
  { 
   */ for(unsigned char a = 0; a < NUM_ARP_ENTRIES; a++)
	{
   //  printf("%d:",a);
	 if (!ARP_Table[a].MAC_Received) 
        { 
		  if (ARP_Table[a].IP.Byte[0]==192 && ARP_Table[a].IP.Byte[1]==168)
		  {
		    cli(); ARP_Request(packet, &ARP_Table[a]); sei();
		  }
		  else 
		  {  
		     if (ARP_Table[ARP_TABLE_ENTRY_ROUTER].MAC_Received)
			 {
		       for (unsigned char i=0; i < 6; i++) ARP_Table[a].ARP_MAC[i] = ARP_Table[ARP_TABLE_ENTRY_ROUTER].ARP_MAC[i];
		       ARP_Table[a].MAC_Received = 1;
			 }  
		  }
        }
    
    }

}
//--------------------------------------------------------------------------
void InitFat(void)
{
#if USE_MMC	
  
 // File fp;
 // char text[50];
  
  
  FileBuffer = &packet[MTU_SIZE - 513];
  InitFat16();
	
  
#endif  
	
}


//--------------------------------------------------------------------------
void SaveCamToSD(char *buffer)
{
#if USE_MMC	
    File fp;
    char filename[13];
	struct time t;
	FileBuffer = FBuffer;
	
	gettime(ActualTime, &t);
	sprintf(filename, "%02d%02d%02d%02d.JPG", t.month, t.day, t.hour, t.minute); 
	filename[12] = '\0';
	printf("\n\rSD: Saving %s...", filename);
#if USE_MCA25_CAM
	
	cli();
	FileOpen(filename, 'a', &fp);
    mca25_cam_status = MCA25_FIRST_DATA;
 
	while (mca25_copy_image_data_to_file_buffer(packet))
	{
    	for (int i=0;i<506;i++) FilePutChar(&fp, packet[i]);		
	}
	for (int i=0;i<506;i++) FilePutChar(&fp, packet[i]);
	FileClose(&fp);
	sei();
	printf_P(PSTR("OK.\n\r"));
#else
	printf_P(PSTR("No CAM!\n\r"));
	
#endif	
#endif  

}					
//--------------------------------------------------------------------------
void ShowConfig(void)
{
  printf ("\n\rMAC : %02X %02X %02X %02X %02X %02X",mymac[0],mymac[1],mymac[2],mymac[3],mymac[4],mymac[5]);
  printf ("\n\rIP  : %d.%d.%d.%d",MYIP[0],MYIP[1],MYIP[2],MYIP[3]);	
  printf ("\n\r---\n\rROUT: %d.%d.%d.%d",ARP_Table[ARP_TABLE_ENTRY_ROUTER].IP.Byte[0],ARP_Table[ARP_TABLE_ENTRY_ROUTER].IP.Byte[1],ARP_Table[ARP_TABLE_ENTRY_ROUTER].IP.Byte[2],ARP_Table[ARP_TABLE_ENTRY_ROUTER].IP.Byte[3]);	
  printf ("\n\rNTP : %d.%d.%d.%d",ARP_Table[ARP_TABLE_ENTRY_NTPSERVER].IP.Byte[0],ARP_Table[ARP_TABLE_ENTRY_NTPSERVER].IP.Byte[1],ARP_Table[ARP_TABLE_ENTRY_NTPSERVER].IP.Byte[2],ARP_Table[ARP_TABLE_ENTRY_NTPSERVER].IP.Byte[3]);	
  printf ("\n\rFTP : %d.%d.%d.%d",ARP_Table[ARP_TABLE_ENTRY_FTPSERVER].IP.Byte[0],ARP_Table[ARP_TABLE_ENTRY_FTPSERVER].IP.Byte[1],ARP_Table[ARP_TABLE_ENTRY_FTPSERVER].IP.Byte[2],ARP_Table[ARP_TABLE_ENTRY_FTPSERVER].IP.Byte[3]);	
  printf ("\n\rSMTP: %d.%d.%d.%d",ARP_Table[ARP_TABLE_ENTRY_SMTPSERVER].IP.Byte[0],ARP_Table[ARP_TABLE_ENTRY_SMTPSERVER].IP.Byte[1],ARP_Table[ARP_TABLE_ENTRY_SMTPSERVER].IP.Byte[2],ARP_Table[ARP_TABLE_ENTRY_SMTPSERVER].IP.Byte[3]);	
  printf_P(PSTR("\n\r---\n\rNTP Enabled=")); if (NTP_Enable) printf_P(PSTR("YES")); else printf_P(PSTR("NO"));
  printf_P(PSTR("\n\r---\n\rMail-Trigger Enabled=")); if (Mail_Trigger_Enable) printf_P(PSTR("YES")); else printf_P(PSTR("NO"));
  printf_P(PSTR("\n\rSMTP AUTH LOGIN=")); 
  if (SMTP_AuthLogin ) 
  { printf_P(PSTR("YES")); 
    printf_P(PSTR("\n\rSMTP User=")); printf("%s", SMTP_Username); 
    printf_P(PSTR("\n\rSMTP Pass=")); printf("%s", SMTP_Password);  
  }
  else printf_P(PSTR("NO"));
  printf_P(PSTR("\n\rCAM Enabled=")); if (CAM_Enable) printf_P(PSTR("YES")); else printf_P(PSTR("NO"));
  printf_P(PSTR("\n\rCAM Store SD-Card Enabled=")); if (CAM_SD_Store_Enable) printf_P(PSTR("YES")); else printf_P(PSTR("NO"));
  printf_P(PSTR("\n\rFTP Push Enabled=")); 
  if (FTP_Push_Enable) 
  { printf_P(PSTR("YES")); 
    printf_P(PSTR("\n\rFTP User=")); printf("%s", FTP_Username); 
    printf_P(PSTR("\n\rFTP Pass=")); printf("%s", FTP_Password);  
  } 
  else printf_P(PSTR("NO"));
  printf_P(PSTR("\n\rCAM Store (SD or FTP) Time=")); if (CAM_SD_Store_Time) printf("%4d",CAM_SD_Store_Time ); else printf_P(PSTR("DISABLED"));
  printf_P(PSTR("\n\rExternal Trigger Enabled=")); 
  if (vars.type_char[EXT_TRIGGER_ADDR] & EXT_TRIGGER_ENABLED > 0)  
  {
    printf_P(PSTR("YES")); 
    printf_P(PSTR("\n\rmin. Trigger Delay=")); printf("%4d",vars.type_int[EXT_TRIGGER_TIME_ADDR]);
 	printf_P(PSTR("\n\rTrigger State=")); 
	if ((vars.type_char[EXT_TRIGGER_ADDR] & EXT_TRIGGER_STATE) > 0) printf_P(PSTR("HIGH")); else printf_P(PSTR("LOW"));
 	printf_P(PSTR("\n\rTrigger Portpin="));
   switch (vars.type_int[EXT_TRIGGER_PIN_ADDR])
   {
    case  0: printf_P(PSTR("B.4")); break; 
	case  1: printf_P(PSTR("D.2")); break; 
	case  2: printf_P(PSTR("D.3"));break; 
	case  4: printf_P(PSTR("D.4"));break; 
	case  8: printf_P(PSTR("D.5"));break; 
	case 16: printf_P(PSTR("D.6"));break; 
    default: printf_P(PSTR("unknown")); break;
   }

  }
  else printf_P(PSTR("NO"));
  
  printf_P(PSTR("\n\n\r"));
  
}

//----------------------------------------------------------------------------
// Setzen und Auswerten des geteilten Speicherbereichs
//----------------------------------------------------------------------------
void UpdateProcessVars(void)
{
  
  if (CheckDelay_ms(AD_Timer))            // nur alle 250ms ausfhren
  {  GetTemperature();                    // benutzt vars-Index 0 bis 6 fr Anlogwerte und Temperaturwerte
	 AD_Timer = SetDelay_ms(250);
  }	 
	 
   if (vars.type_char[29] & 0x01) {  vars.type_char[29] &= ~0x01; SaveCamToSD(NULL); }       // speichern getriggert
   
}


void test(void)
{
  
#if USE_MMC	
    File fp;
    char filename[13]="12345678.txt\0";
	struct time t;
	FileBuffer = FBuffer;
	static char z = 0x30;
	
	FileOpen(filename, 'a', &fp);
 
    for (int i=0;i<2048;i++) FilePutChar(&fp, z);		
	FileClose(&fp);
	z++;
	printf("SAVE");
#endif  

}
//############################################################################
//Hauptprogramm
int main (void)
//############################################################################
{
	unsigned int CAM_Store_Timer, Minuten_Timer, UniversalTimer, Ext_Trigger_Timer;
	unsigned char timeout = 3;
//	WDTCSR = 0x00;
	DDRD  |= (1 << 7);
    PORTD |= (0 << 7);
	UART_Init();
	PORTD |= (1 << 7);
    
	
	InitIP();

	//---- external trigger init ----
	vars.type_char[EXT_TRIGGER_ADDR] |= (DEFAULT_EXT_TRIGGER_ENABLE > 0 ) ? EXT_TRIGGER_ENABLED : 0;
	vars.type_char[EXT_TRIGGER_ADDR] |= (DEFAULT_EXT_TRIGGER_STATE > 0 )  ? EXT_TRIGGER_STATE : 0;
	vars.type_int[EXT_TRIGGER_TIME_ADDR] = DEFAULT_EXT_TRIGGER_TIME;
	vars.type_int[EXT_TRIGGER_PIN_ADDR] = DEFAULT_EXT_TRIGGER_PORTPIN;
	// -----------------------------

    printf_P(PSTR("\n\n\r--=== AVR-Server V1.40 ===---\n\r"));
	
#if USE_MMC	
	unsigned char rueck;
		while ((rueck = mmc_init()) != 0 && timeout--) //ist der Rckgabewert ungleich NULL ist ein Fehler aufgetreten
								//MMC/SD-Karte wird dann neu Initialisiert
			{
			printf ("ERR: no MMC/SD-Card found! (%02X) **\n\r", rueck);
			}
		if (rueck == 0)
		{
	    	printf_P(PSTR("MMC/SD: Ok. "));
		    FileBuffer = FBuffer;
			InitFat();
			MMC_Present = 1;
			
			ReadConfigFile();   // get configuration...
		}	
		 else MMC_Present = 0;
	#else
	 printf_P(PSTR("MMC : not included\n\r"));
		 
	#endif

	DDRD  |= (1 << 7);
    PORTD |= (0 << 7);

    if (!InitNetworkCard()) 
	{ 
	  PORTD |= (1 << 7);
 
	  while(1);     // Endloschleife, wenn kein Netzwerk
 
    }
	//Globale Interrupts Einschalten
	 
    #if USE_RTL8019
    	//Interrupt 4 Mega103/128 Interrupt 0 bei Mega32 
	    //soll auslsen bei ansteigender Flanke
	    Networkcard_INT_Set();
	    //Interrupt 4 oder 0 Einschalten (fr die Netzwerkkarte)
	    Networkcard_INT_Enable();
    #endif

	#if USE_CLOCK
		Start_Clock();
	#endif

     ADC_Init(); // Analogmessung init.
	 ShowConfig();
#if USE_MCA25_CAM
   if(CAM_Enable)
   { 
	//set up camera:
	printf_P(PSTR("CAM : Init...\n\r"));
	printf_P(PSTR("CAM : Debug output is now off!\n\r"));
	
	//DEBUG:
	
	MCA25_ERROR_LED_OFF();
	MCA25_CLOCK_LED_OFF();
	
	MCA25_STATUS_LED_ON();
	mca25_init();
	mca25_configure();	
	MCA25_STATUS_LED_OFF();
   }	
#endif	
	 
	sei ();
	
	
    CAM_Store_Timer = SetDelay_min(1);	 
	
	UniversalTimer = SetDelay_ms(100);
	AD_Timer = SetDelay_ms(250);
	Ext_Trigger_Timer = SetDelay_sec(1);
    
   char mail_state = 0;
 	while (1)
		{ 
		 
#if USE_3C5x9
           do_network_io();
#endif		   

           if (CheckDelay_ms(UniversalTimer))
		   {
	         UpdateProcessVars();	   
		    //------------------------------------------------------------------   
		    
              RequestMACAddr();  
			 
			//------------------------------------------------------------------ 
#if USE_NTP
			if (NTP_Enable) GetNTP_Time(); 
#endif		 

            //------------------------------------------------------------------	      
		    if(Mail_Trigger_Enable)
			{
		    	if (mail_state == 0)  // momentan kein versand getriggert
		        { 
		 	      if (vars.type_int[MAILFLAGS_ADDR] != 0) 
			      {
				    cli();
			   	    printf("MailTrigger\n");
				    sendmail(packet, 0);
				    sei();
				    mail_state = 1;
			      }
		       } else     // versand wurde getriggert
		       {
			    if (vars.type_int[MAILFLAGS_ADDR] == 0) mail_state = 0;
		       }
			}   
           
		   //------------------------------------------------------------------
		   
		    if ((vars.type_char[EXT_TRIGGER_ADDR] & EXT_TRIGGER_ENABLED) > 0) 
            {  
			  unsigned char triggerbit;
			  
			  if (CheckDelay_sec(Ext_Trigger_Timer))
              {
			   switch (vars.type_int[EXT_TRIGGER_PIN_ADDR])
			   {
			    case 0: triggerbit = (PINB >> 4) & 0x01; break; 
				case 1: triggerbit = (PIND >> 2) & 0x01; break; 
				case 2: triggerbit = (PIND >> 3) & 0x01; break; 
				case 4: triggerbit = (PIND >> 4) & 0x01; break; 
				case 8: triggerbit = (PIND >> 5) & 0x01; break; 
				case 16: triggerbit = (PIND >> 6) & 0x01; break; 
				default: triggerbit = 0xff; break;
			   }
               //printf("Bit: %d Time:%d\n\r", triggerbit, vars.type_int[EXT_TRIGGER_TIME_ADDR]); 
			   if (triggerbit == ((vars.type_char[EXT_TRIGGER_ADDR] & EXT_TRIGGER_STATE) > 0 ? 1:0)) 
			   { vars.type_char[EXT_TRIGGER_ADDR] |= EXT_TRIGGERED;
			     Ext_Trigger_Timer = SetDelay_sec(vars.type_int[EXT_TRIGGER_TIME_ADDR]);   // min. Zeit bis zur nchsten Triggerauslsung
			   }
			   else
			   {
				 Ext_Trigger_Timer = SetDelay_sec(0);  // sofort wieder berprfen
			   }
			  } 
			  
			  
            }      
		   //------------------------------------------------------------------
 	       
           if (CAM_SD_Store_Time == 0) CAM_Store_Timer =  SetDelay_min(100); // sorgt dafr, dass bei einer Einstellung von 0 nie der Timer abluft
		                                                                     // und nur ein ext. Trigger das Speichern auslsen kann
		   
		   UniversalTimer = SetDelay_ms(100);

		   }
		   
           //------------------------------------------------------------------
		   
		   if (CheckDelay_min(CAM_Store_Timer) || ((vars.type_char[EXT_TRIGGER_ADDR] & EXT_TRIGGERED) > 0))
		   {  
//		     printf("Ext-Trigger.");
			 vars.type_char[EXT_TRIGGER_ADDR] &= ~EXT_TRIGGERED;                             
			 if (CAM_Enable && CAM_SD_Store_Enable) SaveCamToSD(NULL);
			 //test();
			 if (FTP_Push_Enable) FTP_Push();
			 
			 
		     if (CAM_Enable && CAM_SD_Store_Time) CAM_Store_Timer =  SetDelay_min(CAM_SD_Store_Time);
		   }



	    }
return (1);
}

