//  (C) 2006 Ingo Busker http://www.mikrocontroller.com

#include "main.h"
#include "ntp.h"
#include "socket.h"

#if USE_NTP
PROGMEM char  NTP_Request[] = { 0xd9,0x00,0x0a ,0xfa ,0x00 ,0x00,  
							      0x00 ,0x00 ,0x00 ,0x01 ,0x04 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00, 
								  0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00,  
								  0x00 ,0x00 ,0xc7 ,0xd6 ,0xac ,0x72 ,0x08 ,0x00 ,0x00 ,0x00, '%','E','N','D' };

unsigned char NTP_Enable = DEFAULT_NTP_ENABLE;
unsigned long NextTimeUpdate = 1;           // first update after 5 seconds

void GetNTP_Time(void)
{
  if (NextTimeUpdate < ActualTime) { NextTimeUpdate = ActualTime + 10; cli(); ntp_connect(packet, 0); sei();  }
}



void ntpc(char* buffer, int *bufferlen) {
	unsigned int udpdata;
	unsigned long timestamp = 0L;
	unsigned char *swap1, *swap2;
	struct timedata
	{
	  char dummy[40];
	  unsigned long t_time;
	  
	} *str_udp;
	struct time current_time;
	
	
	//Errechnet startpunkt der Daten im Tcp buffer
	//IP Headerlnge + TCP Headerlnge + Ethernetframe
	//printf("ntp.");
	
	udpdata = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + 14 + 8;
    
	str_udp = ( struct timedata *) &buffer[udpdata];
	swap1 = (char *) &(str_udp->t_time);
	swap2 = (char *) &timestamp;
	swap2[0] = swap1[3]; swap2[1] = swap1[2]; swap2[2] = swap1[1]; swap2[3] = swap1[0];
	
	timestamp += GMT_TIME_CORRECTION; //  UTC +1h
	
	ActualTime = timestamp;           // Uhrzeit setzen
	
	gettime(ActualTime, &current_time);
	
	printf("\n\rNTP: Time is %02d.%02d.%04d  %02d:%02d:%02d", current_time.day, current_time.month, current_time. year, current_time.hour, current_time.minute, current_time.second);
	
	NextTimeUpdate = ActualTime + 3600;   // next update in 1 hour...
}

void ntp_connect(char *buffer, int bufferlen) {
	//Pointer auf Ethernet_Header
  if (ARP_Table[ARP_TABLE_ENTRY_NTPSERVER].MAC_Received)
  {	
	struct Ethernet_Header *ethernet;
	ethernet = (struct Ethernet_Header *)&buffer[ETHER_OFFSET];
	//Pointer auf IP_Header
	struct IP_Header *ip;
	ip = (struct IP_Header *)&buffer[IP_OFFSET];
	//Pointer auf TCP_Header
	struct TCP_Header *tcp;
	tcp = (struct TCP_Header *)&buffer[TCP_OFFSET];

	unsigned int result16;

	ethernet->EnetPacketType = 0x0008; // IP
	ip->IP_Proto = PROT_TCP; // TCP
    
	
	ip->IP_Srcaddr = ARP_Table[ARP_TABLE_ENTRY_NTPSERVER].IP.Long;
	//*((unsigned long *)&NTP_IP[0]);
	for (unsigned char a = 0; a < 6; a++) {
		ethernet->EnetPacketSrc[a] = ARP_Table[ARP_TABLE_ENTRY_NTPSERVER].ARP_MAC[a];
	}

	// FLAG FR UNFRAGMENTIERT SETZEN!
	// !> eigene routine: create_new_ip_header() oder so:
	ip->IP_Vers_Len = 0x45; // version 4, 5x 32bit header lnge
	ip->IP_Tos = 0x00;	// normales paket, keine spez. optionen
	ip->IP_Id = 0x00c0;	// einmalige ID. woher sollen wir die nehmen???
	ip->IP_Frag_Offset = 0x0040;	// don't fragment
	ip->IP_ttl = 64;	// max. hops
	ip->IP_Proto = PROT_UDP;	//Zeigt das hherschichtige Protokoll an 
	// --------- IP header sollte jetzt okay sein

	// !> eigene routine: create_new_tcp_header
	// neue verbindung. also seq und ack auf 0!
	buffer[TCP_ACKNUM+0] = 0;
	buffer[TCP_ACKNUM+1] = 0;
	buffer[TCP_ACKNUM+2] = 0;
	buffer[TCP_ACKNUM+3] = 0;

	buffer[TCP_SEQNUM+0] = 0;
	buffer[TCP_SEQNUM+1] = 0;
	buffer[TCP_SEQNUM+2] = 0;
	buffer[TCP_SEQNUM+3] = 0;

	buffer[TCP_HDRFLAGS+1] = FIN_FLAG; // nur damit tcp_store alles auf 0 lt!

	//Speichert Sequenzcounter und Aknowledgecounter
	tcp_store(buffer);

	//Setzen der flags
//	buffer[TCP_HDRFLAGS+0] = ((20/4) << 4);; // 4bit lnge des tcp-headers in 32bit schritten, rechts davon flags
//	buffer[TCP_HDRFLAGS+1] = SYN_FLAG;

	// low/high-byte entsprechend vertauscht, s. portnummern in socket.h
	buffer[TCP_SRCPORT+0]  = (SOCKET_NTPD & 0xff);
	buffer[TCP_SRCPORT+1]  = (SOCKET_NTPD >> 8);
	buffer[TCP_DESTPORT+0] = (SOCKET_NTPD & 0xff);
	buffer[TCP_DESTPORT+1] = (SOCKET_NTPD >> 8);

//	buffer[TCP_WINDOW+0] = (MTU_SIZE >> 8); // MTU-size ist bestimmt nicht das gleiche wie window. aber besser als 5000 bytes!
//	buffer[TCP_WINDOW+1] = (MTU_SIZE & 0xff);

//	buffer[TCP_URGENTPTR+0] = 0;
//	buffer[TCP_URGENTPTR+1] = 0;

	// !! hier mu ein gltiger ip header im buffer liegen, damit die berechnung hinhaut!
//	tcpdata = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;
	//tcp_add_data (NTP_Request,buffer, &bufferlen);	
	//Erzeugt ein TCP buffer
	
	tcp_make(buffer);
	
	
	upd_add_data (NTP_Request,buffer, &bufferlen);
		ip->IP_Hdr_Cksum = 0x0000;
	
	//Berechnung der IP Header lnge	
	result16 = (ip->IP_Vers_Len & 0x0F) << 2;

	//jetzt wird die Checksumme berechnet
	result16 = checksum (&ip->IP_Vers_Len, result16, 0);

	//schreibt Checksumme ins Packet
	ip->IP_Hdr_Cksum = ((result16 & 0xFF00) >> 8)|((result16 & 0x00FF)<<8);


	//Sendet das erzeugte TCP buffer
	Write_Ethernet_Frame (buffer, bufferlen);
//	printf("NTPCon\n");

  }
  else printf_P(PSTR("Sorry, no MAC for NTP\n\r"));
}
#endif