/*
Copyright (C) 2005 Mark Haemmerling <avr.webserver@markh.de>
          (C) 2006 Ingo Busker http://www.mikrocontroller.com
*/

#include "main.h"
#include "sendmail.h"
#include "socket.h"

PROGMEM char SMTP_HELO[] = "HELO AVRserver\r\n"; // hier absender rein??
PROGMEM char SMTP_RSET[] = "RSET\r\n";
PROGMEM char SMTP_MAIL[] = "MAIL FROM:<ingo.busker@gmx.de>\r\n";
PROGMEM char SMTP_RCPT[] = "RCPT TO:<ingo@localhost.de>\r\n"; // hier user eintragen, an den die mail gehen soll
PROGMEM char SMTP_DATA[] = "DATA\r\n";
PROGMEM char SMTP_TEXT[] = "From: \"ISA-Ctrl\" <ISA-CTRL@no-reply.com>\r\nSubject: Unbekannter Trigger!\r\n\r\nHallo Benutzer,\r\n\r\nkonnte keine Mail zu einem Triggerereignis finden :-(.\r\n";
PROGMEM char SMTP_END[]  = "\r\n-- \r\nSent by the ISA-CTRL embedded mailing subsystem\r\n.\r\n";
PROGMEM char SMTP_QUIT[] = "QUIT\r\n";
PROGMEM char SMTP_AUTH[] = "AUTH LOGIN\r\n";
        char SMTP_Username[] = "ingo\0";
        char SMTP_Password[] = "test\0";
unsigned char SMTP_AuthLogin = 0;
unsigned char Mail_Trigger_Enable = 0;

static const char cb64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";


/*
** encodeblock
**
** encode 3 8-bit binary bytes as 4 '6-bit' characters
*/
void Encodeblock( unsigned char in[3], unsigned char out[4], int len )
{
    out[0] = cb64[ in[0] >> 2 ];
    out[1] = cb64[ ((in[0] & 0x03) << 4) | ((in[1] & 0xf0) >> 4) ];
    out[2] = (unsigned char) (len > 1 ? cb64[ ((in[1] & 0x0f) << 2) | ((in[2] & 0xc0) >> 6) ] : '=');
    out[3] = (unsigned char) (len > 2 ? cb64[ in[2] & 0x3f ] : '=');
}
//----------------------------------------------------------------------------
unsigned char Encode_Base64(char *wort, char *encoded)
{ 
   char in[3], out[4];
   unsigned char len, j=0, i, count=0;
    while( wort[j] != 0) 
	{
        len = 0;
        for( i = 0; i < 3; i++ ) 
		{
            in[i] = wort[j];
            if( wort[j] != 0) { len++; j++; }
              else in[i] = 0;
	     		  
        }
        if( len ) 
		{
            Encodeblock( in, out, len );
            for( i = 0; i < 4; i++ ) { *encoded= out[i]; encoded++;  count++;}
        }
		
    }
	return(count);
}



#define BLOCK_SIZE BlockSize // aus fat.h
//----------------------------------------------------------------------------
void smtp(char* buffer, int *bufferlen) {
	unsigned int tcpdata;
	//Errechnet startpunkt der Daten im Tcp buffer
	//IP Headerlnge + TCP Headerlnge + Ethernetframe
	tcpdata = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;

	//Verwaltung Stackpointer
	unsigned char a;//Stack Speichplatz Default (0..10)
	if (TCP_Stack(buffer,bufferlen,&a) == 1) return; //keine Daten fr Anwendung
	tcp_socket = &tcpsockets[a]; //Pointer auf tcpsockets[a] holen

	//berprft daten
	if (tcp_socket->Status == TCP_SOCKET_OPEN1) {
		unsigned char data = ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0); // wenn daten zu lesen sind
		unsigned int code;
		unsigned int i = 0;
		unsigned char complete = 0;
		
		if (data) {
			buffer[tcpdata+3] = '\0';
			code = atoi(buffer+tcpdata);
		} else {
			code = -1;
		}

		tcp_store(buffer);	
		//Setzen des Ack Flags und PSH Flags	
		buffer[TCP_HDRFLAGS+1] = ACK_FLAG | PSH_FLAG;

		if ((!data) || (code < 500)) {
			//unsigned char Dir_Attrib;
			unsigned char File_Name[13];
			//printf("Smtp(%u),Cs(%u)\n", code, tcp_socket->CommStage);
			switch (tcp_socket->CommStage) {
			case 0:
				if (data) {
					i = sprintf_P(buffer+tcpdata, SMTP_HELO);
					if (SMTP_AuthLogin) tcp_socket->CommStage++;
					 else tcp_socket->CommStage = 5;   
				}
				break;
			case 1:
				if (data) {
					i = sprintf_P(buffer+tcpdata, SMTP_AUTH);
					tcp_socket->CommStage++;
				}
				break;
			case 2:
				if (data) {
				    i = Encode_Base64(SMTP_Username, (buffer+tcpdata));
					sprintf_P(buffer+tcpdata+i, PSTR("\r\n"));
					i+=2 ;
					tcp_socket->CommStage++;
				}
				break;
			case 3:
				if (data) {
					 i = Encode_Base64(SMTP_Password, (buffer+tcpdata));
					 sprintf_P(buffer+tcpdata+i, PSTR("\r\n"));
					i+=2 ;
					tcp_socket->CommStage= 5;
				}
				break;
			case 4:
				if (data) {
					tcp_socket->File_Block_Counter = 0;
					i = sprintf_P(buffer+tcpdata, SMTP_RSET);
					tcp_socket->CommStage++;
				}
				break;
			case 5:
				if (data) {	
				    for (tcp_socket->Data0 = 0; tcp_socket->Data0 < 16; tcp_socket->Data0++) {
						if (vars.type_int[MAILFLAGS_ADDR] & (1<<tcp_socket->Data0)) break;
					}
					sprintf(File_Name, "mail-%02u.txt", tcp_socket->Data0);
					printf(File_Name);
					// lade pointer auf mail text
					tcp_socket->Cluster = 0; //suche im Root Directory
					FileBuffer = buffer+tcpdata;
#if USE_MMC	
					if (FileOpen(File_Name, 'r', &(tcp_socket->fp)))
                    {
						printf("->OK\n\r");
						tcp_socket->Cluster = 1;     // Datei verhanden (besser fp auswerten)
					} else 
					{
						// wenn nicht gefunden, schicke standard-mail
						printf("->NotFound\n\r");
						tcp_socket->Cluster = 0;
					}
#endif 
					i = sprintf_P(buffer+tcpdata, SMTP_MAIL);
					tcp_socket->CommStage++;
				}
				break;
			case 6:
				if (data) {
					i = sprintf_P(buffer+tcpdata, SMTP_RCPT);
					tcp_socket->CommStage++;
				}
				break;
			case 7:
				if (data) {
					i = sprintf_P(buffer+tcpdata, SMTP_DATA);
					tcp_socket->CommStage++;
				}
				break;
			case 8:
				if (((!data) && (tcp_socket->File_Block_Counter > 0)) || // wenn keine response vom smtp, mache nur weiter, wenn dies eine fortsetzung von daten ist
				(data)) { // oder wenn eine response vom smtp server kam (nur am anfang, dann nicht mehr innerhalb der daten)
					if (tcp_socket->Cluster != 0) 
					{
						// block aus datei laden
#if USE_MMC	
						i = FileReadSector(&(tcp_socket->fp)); 
#endif 
						if (i < 512) complete = 1;
					} else 
					 {
						// datei nicht gefunden, sende standard-mail
						i = sprintf_P(buffer+tcpdata, SMTP_TEXT);
						// muss in tcp buffer passen!!!
						complete = 1;
					 }
					if (complete) {
						vars.type_int[MAILFLAGS_ADDR] &= ~(1<<tcp_socket->Data0);
						if (vars.type_int[MAILFLAGS_ADDR]) {
							tcp_socket->CommStage = 1; // mache weiter mit RSET
						} else {
							tcp_socket->CommStage++; // beende verbindung
						}
						// hnge ende-code an (alleinstehender ".")
						i += sprintf_P(buffer+tcpdata+i, SMTP_END);
					}
				}
				break;
			default:
				if (data) {
					i = sprintf_P(buffer+tcpdata, SMTP_QUIT);
					tcp_socket->CommStage++;
				}
				break;
			}
		} else {
			// fehler. quit senden, commstage setzen, da es nicht mehr oben greift
			printf("SmtpErr(%u)\n\r", code);
			i = sprintf_P(buffer+tcpdata, SMTP_QUIT);
			tcp_socket->CommStage = -1;
		}

		TCP_New_Packtlen(buffer, bufferlen, tcpdata + i);
		tcp_make(buffer);			
		Write_Ethernet_Frame (buffer,*bufferlen);	
	}
}

void sendmail(char *buffer, int bufferlen) 
{
 if (ARP_Table[ARP_TABLE_ENTRY_NTPSERVER].MAC_Received)
  {	
		//Pointer auf Ethernet_Header
	struct Ethernet_Header *ethernet;
	ethernet = (struct Ethernet_Header *)&buffer[ETHER_OFFSET];
	//Pointer auf IP_Header
	struct IP_Header *ip;
	ip = (struct IP_Header *)&buffer[IP_OFFSET];
	//Pointer auf TCP_Header
	struct TCP_Header *tcp;
	tcp = (struct TCP_Header *)&buffer[TCP_OFFSET];

	unsigned int tcpdata;

	ethernet->EnetPacketType = 0x0008; // IP
	ip->IP_Proto = PROT_TCP; // TCP

	ip->IP_Srcaddr = ARP_Table[ARP_TABLE_ENTRY_SMTPSERVER].IP.Long;
	
	for (unsigned char a = 0; a < 6; a++) {
		ethernet->EnetPacketSrc[a] = ARP_Table[ARP_TABLE_ENTRY_SMTPSERVER].ARP_MAC[a];
	}

	// FLAG FR UNFRAGMENTIERT SETZEN!
	// !> eigene routine: create_new_ip_header() oder so:
	ip->IP_Vers_Len = 0x45; // version 4, 5x 32bit header lnge
	ip->IP_Tos = 0x00;	// normales paket, keine spez. optionen
	ip->IP_Id = 0x00c0;	// einmalige ID. woher sollen wir die nehmen???
	ip->IP_Frag_Offset = 0x0040;	// don't fragment
	ip->IP_ttl = 64;	// max. hops
	ip->IP_Proto = PROT_TCP;	//Zeigt das hherschichtige Protokoll an 
	// --------- IP header sollte jetzt okay sein

	// !> eigene routine: create_new_tcp_header
	// neue verbindung. also seq und ack auf 0!
	buffer[TCP_ACKNUM+0] = 0;
	buffer[TCP_ACKNUM+1] = 0;
	buffer[TCP_ACKNUM+2] = 0;
	buffer[TCP_ACKNUM+3] = 0;

	buffer[TCP_SEQNUM+0] = 0;
	buffer[TCP_SEQNUM+1] = 0;
	buffer[TCP_SEQNUM+2] = 0;
	buffer[TCP_SEQNUM+3] = 0;

	buffer[TCP_HDRFLAGS+1] = FIN_FLAG; // nur damit tcp_store alles auf 0 lt!

	//Speichert Sequenzcounter und Aknowledgecounter
	tcp_store(buffer);

	//Setzen der flags
	buffer[TCP_HDRFLAGS+0] = ((20/4) << 4);; // 4bit lnge des tcp-headers in 32bit schritten, rechts davon flags
	buffer[TCP_HDRFLAGS+1] = SYN_FLAG;

	// low/high-byte entsprechend vertauscht, s. portnummern in socket.h
	buffer[TCP_SRCPORT+0]  = (SOCKET_SMTP & 0xff);
	buffer[TCP_SRCPORT+1]  = (SOCKET_SMTP >> 8);
	buffer[TCP_DESTPORT+0] = (SOCKET_SENDMAIL & 0xff);
	buffer[TCP_DESTPORT+1] = (SOCKET_SENDMAIL >> 8);

	buffer[TCP_WINDOW+0] = (MTU_SIZE >> 8); // MTU-size ist bestimmt nicht das gleiche wie window. aber besser als 5000 bytes!
	buffer[TCP_WINDOW+1] = (MTU_SIZE & 0xff);

	buffer[TCP_URGENTPTR+0] = 0;
	buffer[TCP_URGENTPTR+1] = 0;

	// !! hier mu ein gltiger ip header im buffer liegen, damit die berechnung hinhaut!
	tcpdata = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;
	TCP_New_Packtlen(buffer, &bufferlen, tcpdata);
	
	//Erzeugt ein TCP buffer
	tcp_make(buffer);
	
	// !> hier globales flag setzen, da demnchst eine TCP-verbindung remote 25 -> local 64
	//    erwartet wird. damit diese verb. akzeptiert wird, MUSS dieses flag gesetzt sein!
	//    nach eingegangener verb. flag wieder lschen!!
	
	//Sendet das erzeugte TCP buffer
	Write_Ethernet_Frame (buffer, bufferlen);
	printf("MailSyn\n\r");
  }
  else printf_P(PSTR("Sorry, no MAC for SMTP\n\r"));

}
